dect
/
libpcap
Archived
13
0
Fork 0

Check for <linux/can.h> rather than <linux/can/version.h>.

Not all Linux kernels that can support SocketCAN sniffing have
<linux/can/version.h>, and we don't include it directly.  We *do*
include <linux/can.h>, so check for that.

Patch changed not to bother checking for the existence of <sys/socket.h>
- we already assume it exists on all platforms that support packet
capture, including Linux.  I also changed the Bluetooth "not supported
on this OS" message to look like the one for CANbus, giving the host OS.

Signed-off-by: Guy Harris <guy@alum.mit.edu>
This commit is contained in:
Felix Obenhuber 2009-12-30 17:14:20 -08:00 committed by Guy Harris
parent 72f5572c50
commit 03238ec05d
2 changed files with 20 additions and 98 deletions

110
configure vendored
View File

@ -10335,8 +10335,8 @@ fi
;;
*)
{ echo "$as_me:$LINENO: no Bluetooth sniffing support" >&5
echo "$as_me: no Bluetooth sniffing support" >&6;}
{ echo "$as_me:$LINENO: no Bluetooth sniffing support implemented for $host_os" >&5
echo "$as_me: no Bluetooth sniffing support implemented for $host_os" >&6;}
;;
esac
@ -10354,26 +10354,21 @@ fi
if test "x$enable_can" != "xno" ; then
case "$host_os" in
linux*)
if test "${ac_cv_header_linux_can_version_h+set}" = set; then
{ echo "$as_me:$LINENO: checking for linux/can/version.h" >&5
echo $ECHO_N "checking for linux/can/version.h... $ECHO_C" >&6; }
if test "${ac_cv_header_linux_can_version_h+set}" = set; then
{ echo "$as_me:$LINENO: checking for linux/can.h" >&5
echo $ECHO_N "checking for linux/can.h... $ECHO_C" >&6; }
if test "${ac_cv_header_linux_can_h+set}" = set; then
echo $ECHO_N "(cached) $ECHO_C" >&6
fi
{ echo "$as_me:$LINENO: result: $ac_cv_header_linux_can_version_h" >&5
echo "${ECHO_T}$ac_cv_header_linux_can_version_h" >&6; }
else
# Is the header compilable?
{ echo "$as_me:$LINENO: checking linux/can/version.h usability" >&5
echo $ECHO_N "checking linux/can/version.h usability... $ECHO_C" >&6; }
cat >conftest.$ac_ext <<_ACEOF
cat >conftest.$ac_ext <<_ACEOF
/* confdefs.h. */
_ACEOF
cat confdefs.h >>conftest.$ac_ext
cat >>conftest.$ac_ext <<_ACEOF
/* end confdefs.h. */
$ac_includes_default
#include <linux/can/version.h>
#include <sys/socket.h>
#include <linux/can.h>
_ACEOF
rm -f conftest.$ac_objext
if { (ac_try="$ac_compile"
@ -10392,94 +10387,19 @@ eval "echo \"\$as_me:$LINENO: $ac_try_echo\"") >&5
test -z "$ac_c_werror_flag" ||
test ! -s conftest.err
} && test -s conftest.$ac_objext; then
ac_header_compiler=yes
ac_cv_header_linux_can_h=yes
else
echo "$as_me: failed program was:" >&5
sed 's/^/| /' conftest.$ac_ext >&5
ac_header_compiler=no
ac_cv_header_linux_can_h=no
fi
rm -f core conftest.err conftest.$ac_objext conftest.$ac_ext
{ echo "$as_me:$LINENO: result: $ac_header_compiler" >&5
echo "${ECHO_T}$ac_header_compiler" >&6; }
# Is the header present?
{ echo "$as_me:$LINENO: checking linux/can/version.h presence" >&5
echo $ECHO_N "checking linux/can/version.h presence... $ECHO_C" >&6; }
cat >conftest.$ac_ext <<_ACEOF
/* confdefs.h. */
_ACEOF
cat confdefs.h >>conftest.$ac_ext
cat >>conftest.$ac_ext <<_ACEOF
/* end confdefs.h. */
#include <linux/can/version.h>
_ACEOF
if { (ac_try="$ac_cpp conftest.$ac_ext"
case "(($ac_try" in
*\"* | *\`* | *\\*) ac_try_echo=\$ac_try;;
*) ac_try_echo=$ac_try;;
esac
eval "echo \"\$as_me:$LINENO: $ac_try_echo\"") >&5
(eval "$ac_cpp conftest.$ac_ext") 2>conftest.er1
ac_status=$?
grep -v '^ *+' conftest.er1 >conftest.err
rm -f conftest.er1
cat conftest.err >&5
echo "$as_me:$LINENO: \$? = $ac_status" >&5
(exit $ac_status); } >/dev/null && {
test -z "$ac_c_preproc_warn_flag$ac_c_werror_flag" ||
test ! -s conftest.err
}; then
ac_header_preproc=yes
else
echo "$as_me: failed program was:" >&5
sed 's/^/| /' conftest.$ac_ext >&5
ac_header_preproc=no
fi
rm -f conftest.err conftest.$ac_ext
{ echo "$as_me:$LINENO: result: $ac_header_preproc" >&5
echo "${ECHO_T}$ac_header_preproc" >&6; }
# So? What about this header?
case $ac_header_compiler:$ac_header_preproc:$ac_c_preproc_warn_flag in
yes:no: )
{ echo "$as_me:$LINENO: WARNING: linux/can/version.h: accepted by the compiler, rejected by the preprocessor!" >&5
echo "$as_me: WARNING: linux/can/version.h: accepted by the compiler, rejected by the preprocessor!" >&2;}
{ echo "$as_me:$LINENO: WARNING: linux/can/version.h: proceeding with the compiler's result" >&5
echo "$as_me: WARNING: linux/can/version.h: proceeding with the compiler's result" >&2;}
ac_header_preproc=yes
;;
no:yes:* )
{ echo "$as_me:$LINENO: WARNING: linux/can/version.h: present but cannot be compiled" >&5
echo "$as_me: WARNING: linux/can/version.h: present but cannot be compiled" >&2;}
{ echo "$as_me:$LINENO: WARNING: linux/can/version.h: check for missing prerequisite headers?" >&5
echo "$as_me: WARNING: linux/can/version.h: check for missing prerequisite headers?" >&2;}
{ echo "$as_me:$LINENO: WARNING: linux/can/version.h: see the Autoconf documentation" >&5
echo "$as_me: WARNING: linux/can/version.h: see the Autoconf documentation" >&2;}
{ echo "$as_me:$LINENO: WARNING: linux/can/version.h: section \"Present But Cannot Be Compiled\"" >&5
echo "$as_me: WARNING: linux/can/version.h: section \"Present But Cannot Be Compiled\"" >&2;}
{ echo "$as_me:$LINENO: WARNING: linux/can/version.h: proceeding with the preprocessor's result" >&5
echo "$as_me: WARNING: linux/can/version.h: proceeding with the preprocessor's result" >&2;}
{ echo "$as_me:$LINENO: WARNING: linux/can/version.h: in the future, the compiler will take precedence" >&5
echo "$as_me: WARNING: linux/can/version.h: in the future, the compiler will take precedence" >&2;}
;;
esac
{ echo "$as_me:$LINENO: checking for linux/can/version.h" >&5
echo $ECHO_N "checking for linux/can/version.h... $ECHO_C" >&6; }
if test "${ac_cv_header_linux_can_version_h+set}" = set; then
echo $ECHO_N "(cached) $ECHO_C" >&6
else
ac_cv_header_linux_can_version_h=$ac_header_preproc
fi
{ echo "$as_me:$LINENO: result: $ac_cv_header_linux_can_version_h" >&5
echo "${ECHO_T}$ac_cv_header_linux_can_version_h" >&6; }
fi
if test $ac_cv_header_linux_can_version_h = yes; then
{ echo "$as_me:$LINENO: result: $ac_cv_header_linux_can_h" >&5
echo "${ECHO_T}$ac_cv_header_linux_can_h" >&6; }
if test $ac_cv_header_linux_can_h = yes; then
cat >>confdefs.h <<\_ACEOF
#define PCAP_SUPPORT_CAN 1

View File

@ -1276,7 +1276,7 @@ if test "x$enable_bluetooth" != "xno" ; then
)
;;
*)
AC_MSG_NOTICE(no Bluetooth sniffing support)
AC_MSG_NOTICE(no Bluetooth sniffing support implemented for $host_os)
;;
esac
AC_SUBST(PCAP_SUPPORT_BT)
@ -1291,11 +1291,13 @@ if test "x$enable_can" != "xno" ; then
dnl check for CAN sniffing support
case "$host_os" in
linux*)
AC_CHECK_HEADER(linux/can/version.h,
AC_CHECK_HEADER(linux/can.h,
[ AC_DEFINE(PCAP_SUPPORT_CAN, 1, [target host supports CAN sniffing])
CAN_SRC=pcap-can-linux.c
AC_MSG_NOTICE(CAN sniffing is supported)],
AC_MSG_NOTICE(CAN sniffing is not supported) )
AC_MSG_NOTICE(CAN sniffing is not supported),
[#include <sys/socket.h>]
)
;;
*)
AC_MSG_NOTICE(no CAN sniffing support implemented for $host_os)